function AddCallback(object, event, callback)
    if (object[event] == nil) then
        object[event] = callback;
    else
        if (type(object[event]) == "table") then
            table.insert(object[event], callback);
        else
            object[event] = {object[event], callback};
        end
    end
    return callback;
end

function RemoveCallback(object, event, callback)
    if (object[event] == callback) then
        object[event] = nil;
    else
        if (type(object[event]) == "table") then
            local size = table.getn(object[event]);
            for i = 1, size do
                if (object[event][i] == callback) then
                    table.remove(object[event], i);
                    break;
                end
            end
        end
    end
end

function FireEvent(sender, event, args)
	if type(event)=="function" then
		event(sender, args);
	else
		if type(event)=="table" then
			local size = table.getn(event);
			local i;
			for i=1,size do
				if type(event[i])=="function" then
					event[i](sender, args);
				end
			end
		end
	end
end