ToggleWindow = class(WindowBasic);

local Constants =
{
	Size =
	{
		Width = 35,
		Height = 35
	}
}

local shortcutImages = {};

function ToggleWindow:Constructor()
	self.AlwaysVisible = true;
	WindowBasic.Constructor(self);
	
	self:SetPosition(tonumber(Settings.ToggleWindow.Position.Left) or 100, tonumber(Settings.ToggleWindow.Position.Top) or 100);
	self:SetSize(Constants.Size.Width, Constants.Size.Height);
	self:SetVisible(true);
	self:SetOpacity(GetOpacityFromSettings(Settings.ToggleWindow));
	
	self.Button = Turbine.UI.Control();
	self.Button:SetParent(self);
	self.Button:SetPosition(0,0);
	self.Button:SetSize(Constants.Size.Width, Constants.Size.Height);
	self.Button:SetBlendMode(Turbine.UI.BlendMode.AlphaBlend);
	SetIconImage(shortcutImages, self.Button, "Toggle");
	self.Button.MouseEnter = function(sender,args)
		SetIconImage(shortcutImages, self.Button, "Toggle_Hover");
	end
	
	self.Button.MouseLeave = function(sender,args)
		SetIconImage(shortcutImages, self.Button, "Toggle");
	end
	
	self.Button.MouseDown = function(sender, args)
		if args.Button == Turbine.UI.MouseButton.Left then
			sender.DragStartX = args.X;
			sender.DragStartY = args.Y;
			sender.Dragging = true;
			sender.Dragged = false;
		end
	end
	
	self.Button.MouseUp = function(sender, args) 
		if args.Button == Turbine.UI.MouseButton.Left then			
			sender.Dragging = false;
			if not sender.Dragged then
				poeticalWindow:Toggle();
			end
		end
	end
	
	self.Button.MouseMove = function(sender,args)
		if sender.Dragging then
			local left, top = self:GetPosition();
			self:SetPosition(left + (args.X - sender.DragStartX), top + args.Y - sender.DragStartY);
			sender:SetPosition(0, 0);
			sender.Dragged = true;

			if self:GetLeft() > Turbine.UI.Display.GetWidth() - Constants.Size.Width then
				self:SetLeft(Turbine.UI.Display.GetWidth() - Constants.Size.Width);				
			end
			if self:GetLeft() < 0 then
				self:SetLeft(0);				
			end			
			if self:GetTop() > Turbine.UI.Display.GetHeight() - Constants.Size.Height then
				self:SetTop(Turbine.UI.Display.GetHeight() - Constants.Size.Height);				
			end
			if self:GetTop() < 0 then
				self:SetTop(0);				
			end			
		end
	end
	
	self.VisibleChanged = function(sender, args)
		if self:IsVisible() then
			CheckWindowPosition(self);
		end
	end
end
