WindowLotro = class(Turbine.UI.Lotro.Window);

local Constants =
{
	Size =
	{
		Width = 34,
		Height = 34
	},
	Offset =
	{
		Width = 4,
		Height = 6
	}
}

function WindowLotro:Constructor()
	Turbine.UI.Lotro.Window.Constructor(self);
	
	self.UIHidden = false;
	self.ESCCount = 0;
	KeyActions(self);
end

function WindowLotro:SetResizer(minimumWidth, minimumHeight)
	self.resizeCtrl = Turbine.UI.Control();
	self.resizeCtrl:SetParent(self);
	self.resizeCtrl:SetSize(Constants.Size.Width, Constants.Size.Height);
	self.resizeCtrl:SetStretchMode(1);
	self.resizeCtrl:SetBackColor(Turbine.UI.Color(1.0, 1.0, 1.0, 1.0));
	self.resizeCtrl:SetBackColorBlendMode(Turbine.UI.BlendMode.Multiply);
	self.resizeCtrl:SetBackground(Globals.Icons.WindowResizer);
	self.resizeCtrl:SetZOrder(self:GetZOrder() - 1);
	self:SetResizerPosition(); 

	self.resizeCtrl.MouseDown = function(sender,args)
	  sender.dragStartX = args.X;
	  sender.dragStartY = args.Y;
	  sender.dragging = true;
	end
		
	self.resizeCtrl.MouseUp = function(sender,args)
	  sender.dragging = false;
	end
	
	self.resizeCtrl.MouseMove = function(sender,args)
		local width, height = self:GetSize();
		
		if (sender.dragging) then
			self:SetSize(width + (args.X - sender.dragStartX), 	height + (args.Y - sender.dragStartY));
			if (self:GetWidth() < minimumWidth) then
				self:SetWidth(minimumWidth);
			end
			if (self:GetHeight() < minimumHeight) then
				self:SetHeight(minimumHeight);
			end
			local displayWidth, displayHeight = Turbine.UI.Display.GetSize();
			if (self:GetLeft() + self:GetWidth() > displayWidth) then
				self:SetWidth(self:GetWidth() - (self:GetLeft() + self:GetWidth() - displayWidth));
			end
			if (self:GetTop() + self:GetHeight() > displayHeight) then
				self:SetHeight(self:GetHeight() - (self:GetTop() + self:GetHeight() - displayHeight));
			end
			self:LayoutControls();
		end
		
		self:SetResizerPosition(); 
	end
end

function WindowLotro:SetResizerPosition()
	self.resizeCtrl:SetPosition(self:GetWidth() - Constants.Size.Width - Constants.Offset.Width, self:GetHeight() - Constants.Size.Height - Constants.Offset.Height); 
end

