WordWrapper = class(Turbine.UI.Control);

function WordWrapper:Constructor(parent)
	Turbine.UI.Control.Constructor(self);

	self:SetParent(parent);
	
	self.Label = Turbine.UI.Label();
	self.Label:SetParent(self);
	self.Label:SetMultiline(false);
	self.Label:SetTextAlignment(Turbine.UI.ContentAlignment.MiddleLeft);
	self.Label:SetFont(Globals.Fonts.ListBox);
	self.Label:SetPosition(0, -100);
	self.Label:SetHeight(100);

	self.ScrollBar = Turbine.UI.Lotro.ScrollBar();
	self.ScrollBar:SetParent(self.Label);
	self.ScrollBar:SetOrientation(Turbine.UI.Orientation.Horizontal);
	self.ScrollBar:SetPosition(0, 36);
	self.ScrollBar:SetZOrder(self.Label:GetZOrder() + 1);
	
	self.Label:SetHorizontalScrollBar(self.ScrollBar);
end

function WordWrapper:GetTextLength(text)
	local startWidth = text:len() * 8;
	local endWidth = 1200;
	local step = 8;
	
	if startWidth > endWidth then
		startWidth = endWidth
	end

	self.Label:SetWidth(startWidth);
	self.ScrollBar:SetWidth(startWidth);
	self.Label:SetText(text);

	local adjust = false;
	if not self.ScrollBar:IsVisible() then
		step = -8;
		endWidth = 0;
		adjust = true;
	end

	local textWidth = startWidth;
	for width = startWidth, endWidth, step do
		self.Label:SetWidth(width);
		self.ScrollBar:SetWidth(width);
		if self.ScrollBar:IsVisible() == adjust then
			textWidth = width;
			if adjust then
				textWidth = textWidth - step;
			end
			break;
		end
	end
	
	if textWidth == 0 then
		textWidth = 8;
	end
	
	return textWidth;
end
